saa/routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});


Route::middleware('auth')->group(function () {


    Route::middleware('passwordChanged')->group(function () {
        //Route vers le front
        Route::prefix('front')->namespace('Front')->group(function () {

            //Route notifications
            Route::get('/notifications/unread','NotificationController@getUnreadNotificationOfUser');
            Route::get('/notifications/all', 'NotificationController@getAllNotification');
            Route::get('/notifications/markasread', 'NotificationController@markAsRead');
            Route::get('/notifications/delete', 'NotificationController@deleteNotification');
            Route::delete('/notifications/delete/{id}', 'NotificationController@deleteOneNotification');
            
            //Route offre
            //Route accessible que par les ancien eleve - responsable ou admin du forum ou admin
            Route::middleware('accessFrontCreateOffre')->group(function () {
                route::get('/frontOffre/create', 'OffreController@create')->name('front.offre.create');
                route::post('/frontOffre', 'OffreController@store')->name('front.offre.store');
            });
            //Route accessible que par l'utilisateur de l'offre ou admin
            Route::middleware('accessFrontEditOffre')->group(function () {
                route::patch('/frontOffre/{offre}', 'OffreController@update')->name('front.offre.update');
                route::get('/frontOffre/{offre}/edit', 'OffreController@edit')->name('front.offre.edit');
                route::delete('/frontOffre/{offre}', 'OffreController@destroy')->name('front.offre.destroy');
            });
            //Route accessible par tous
            route::get('/frontOffre', 'OffreController@index')->name('front.offre.index');       
            route::get('/frontOffre/{offre}', 'OffreController@show')->name('front.offre.show');        
            Route::any('/frontOffre/search', 'OffreController@search')->name('front.offre.search');
            Route::get('/frontForum/addFavoriteOffre/{offre}', 'OffreController@addFavorite')->name('front.offre.addFavorite');
            Route::get('/frontForum/removeFavoriteOffre/{offre}', 'OffreController@removeFavorite')->name('front.offre.removeFavorite');


            //Route forum
            //Route accessible que par l'utilisateur du forum ou admin 
            Route::middleware('accessFrontEditForum')->group(function () {
                route::patch('/frontForum/{topic}', 'ForumController@update')->name('front.forum.update');
                route::get('/frontForum/{topic}/edit', 'ForumController@edit')->name('front.forum.edit');
                route::delete('/frontForum/{topic}', 'ForumController@destroy')->name('front.forum.destroy');
            });
            //Route accessible par tous
            route::get('/frontForum', 'ForumController@index')->name('front.forum.index');
            route::get('/frontForum/create', 'ForumController@create')->name('front.forum.create');
            route::post('/frontForum', 'ForumController@store')->name('front.forum.store');
            route::get('/frontForum/{topic}', 'ForumController@show')->name('front.forum.show');
            Route::post('/frontForum/resolu/{topic}', 'ForumController@resoluForum')->name('front.forum.resolu');
            Route::get('/frontForum/addFavoriteTopic/{topic}', 'ForumController@addFavorite')->name('front.forum.addFavorite');
            Route::get('/frontForum/removeFavoriteTopic/{topic}', 'ForumController@removeFavorite')->name('front.forum.removeFavorite');
            Route::get('/mesForums', 'ForumController@indexMesForums')->name('front.mesForum.index');
            Route::any('/mesForums/search', 'ForumController@searchMesForums')->name('front.mesForum.search');


            //Route categorie
            //Route accessible par tous
            route::get('/frontCaregorie', 'CategorieController@index')->name('front.categorie.index');
            route::get('/frontCaregorie/{categorie}', 'CategorieController@show')->name('front.categorie.show');
            Route::any('/frontCaregorie/search/{categorie}', 'CategorieController@search')->name('front.categorie.search');


            //Route reponses forums
            //Route accessible par tous
            Route::post('/reponseTopic/{topic}', 'ReponseController@store')->name('front.reponse.store');
            Route::patch('/reponseTopic/{reponseTopic}', 'ReponseController@update')->name('front.reponse.update');
            Route::delete('/reponseTopic/{reponseTopic}', 'ReponseController@destroy')->name('front.reponse.destroy');


            //Route questionnaire
            Route::middleware('accessFrontQuestionnaire')->group(function () {
                Route::get('/questionnaire', 'QuestionnaireController@index')->name('front.questionnaire.index');
                Route::get('/questionnaire/{questionnaire}', 'QuestionnaireController@show')->name('front.questionnaire.show');
                Route::post('/questionnaire/reponseStore/{questionnaire}', 'QuestionnaireController@reponseStore')->name('front.questionnaire.reponseStore');
                Route::any('/questionnaire/search', 'QuestionnaireController@search')->name('front.questionnaire.search');

                Route::middleware('responsableQuestionnaire')->group(function () {
                    Route::get('/questionnaire/responsableQuestionnaire/create', 'QuestionnaireController@create')->name('front.questionnaire.create');
                    Route::post('/questionnaire/responsableQuestionnaire/store', 'QuestionnaireController@store')->name('front.questionnaire.store');
                    Route::get('/questionnaire/responsableQuestionnaire/{questionnaire}/edit', 'QuestionnaireController@edit')->name('front.questionnaire.edit');
                    route::patch('/questionnaire/responsableQuestionnaire/{questionnaire}', 'QuestionnaireController@update')->name('front.questionnaire.update');
                
                    Route::get('/questionnaire/{questionnaire}/{utilisateur}', 'QuestionnaireController@showUser')->name('front.questionnaire.showUser');
                    
                    //Route pdf
                    Route::get('/dynamic_pdf/pdf/{questionnaire}/{utilisateur}', 'QuestionnaireController@pdf')->name('front.questionnaire.pdf');
                    Route::get('/dynamic_pdf/allpdf/{questionnaire}/', 'QuestionnaireController@allpdf')->name('front.questionnaire.allpdf');
                });    
            });

            //Route profil
            Route::get('/profil', 'ProfilController@profil')->name('front.profil.index');
            Route::get('/favoris', 'ProfilController@favoris')->name('front.profil.favoris');
            Route::put('/profilUpdate', 'ProfilController@updateProfil')->name('front.profil.update');
            Route::put('/profilDesactive', 'ProfilController@desactiveAccount')->name('front.profil.desactive');
            Route::delete('/profilDelete', 'ProfilController@deleteAccount')->name('front.profil.delete');
        });

        //Route vers le back
        Route::middleware('admin')->group(function () {
            Route::prefix('admin')->namespace('Admin')->group(function () {
                Route::name('admin')->get('/', 'AdminController@index');
                Route::resource('/offre', 'OffreController');
                Route::resource('/forum', 'ForumController');
                Route::resource('/questionnaire', 'QuestionnaireController');
                Route::resource('/user', 'UserController');
                Route::resource('/categorie', 'CategorieController');
                Route::resource('/role', 'RoleController');
                Route::patch('/user/active/{user}', 'UserController@active')->name('user.active');
                Route::get('/questionnaire/{questionnaire}/elements-questionnaire/create', 'ElementQuestionnaireController@create')->name('elements-questionnaire.create');
                Route::post('/questionnaire/{questionnaire}/elements-questionnaire', 'ElementQuestionnaireController@store')->name('elements-questionnaire.store');
                route::patch('/questionnaire/{questionnaire}/elements-questionnaire/{element}', 'ElementQuestionnaireController@update')->name('elements-questionnaire.update');
                route::get('/questionnaire/{questionnaire}/elements-questionnaire/{element}/edit', 'ElementQuestionnaireController@edit')->name('elements-questionnaire.edit');
                route::delete('/questionnaire/{questionnaire}/elements-questionnaire/{element}', 'ElementQuestionnaireController@destroy')->name('elements-questionnaire.destroy');
            });
        });
    });
    
    Route::get('/home', 'HomeController@index')->name('home');
    
    Route::post('/changePassword', 'HomeController@changePassword')->name('change-password');
});

    Auth::routes();

saa/app/Models/Categorie.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Categorie extends Model
{
    protected $primaryKey = 'id_categorie';

    protected $fillable = [
        'titre_categorie', 'description_categorie', 'logo_categorie'
    ];

    public function topics()
    {
        return $this->hasMany('App\Models\Topic', 'categorie_id', 'id_categorie')->latest();
    }
}

saa/app/Http/Controllers/Admin/CategorieController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Models\Categorie;
use Exception;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Http\Response;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Validator;

class CategorieController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.categorie.indexCategorie', ['categories' => Categorie::all()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.categorie.createCategorie');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validateData($request, null);

        $categorie = new Categorie();

        $this->save($categorie, $request);

        return redirect()->route('categorie.index')->withToastSuccess('Categorie créer avec succès !!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Categorie $categorie)
    {
        return view ('admin.categorie.editCategorie', ['categorie' => $categorie]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Categorie $categorie)
    {
        $this->validateData($request, $categorie);

        $this->save($categorie, $request);

        return redirect()->route('categorie.index')->withToastSuccess('Catégorie edité avec succès !!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Categorie $categorie)
    {
        if($categorie->delete())
        {
            return redirect()->route('categorie.index')->withToastSuccess('Catégorie supprimé avec succès !!');
        }else
        return redirect()->route('categorie.index')->withToastError('Erreur lors de la suppression de la categorie !!');
    }

    private function save(Categorie $categorie, Request $request)
    {
        $categorie->titre_categorie = $request->titre_categorie;
        $categorie->description_categorie = $request->description_categorie;
        $categorie->save();
        $this->storeFile($categorie);
    }

    private function validateData(Request $request, $categorie)
    {
        if($categorie != null)
        {
            return Validator::make($request->all(),[
                'titre_categorie' => 'required|string|max:255|'.Rule::unique('categories')->ignore($categorie->id_categorie, 'id_categorie'),
                'description_categorie' => 'required|string|max:255',
                'logo_categorie' => 'image|mimes:jpeg,png,jpg,gif,svg|max:2048'
            ])->validate();
        }
        else
        {
            return Validator::make($request->all(),[
                'titre_categorie' => 'required|string|max:255|',
                'description_categorie' => 'required|string|max:255',
                'logo_categorie' => 'required|image|mimes:jpeg,png,jpg,gif,svg|max:2048'
            ])->validate();
        }
    }

    private function storeFile(Categorie $categorie)
    {
        if(request('logo_categorie'))
        {
            $categorie->update([
                'logo_categorie' => request()->file('logo_categorie')->store('categorieLogo')
            ]);
        }
    }
}

saa/app/Http/Controllers/Front/CategorieController.php
<?php

namespace App\Http\Controllers\Front;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Categorie;
use App\Models\Topic;

class CategorieController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $lesCategories = Categorie::orderBy('created_at' , 'DESC', 'updated_at' ,'DESC')->paginate(12);
        return view ('front.categorie.indexCategorie')->with("lesCategories",$lesCategories);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function show(Categorie $categorie)
    {
        $lesTopics = Topic::where('categorie_id', $categorie->id_categorie)->orderBy('created_at' , 'DESC', 'updated_at' ,'DESC')->latest()->paginate(10);
        return view ('front.categorie.showCategorie', ['lesTopics' => $lesTopics, 'categorie' => $categorie]);
    }

    public function search(Request $request, Categorie $categorie)
    {
        $search = $request->search;
        $lesTopics = Topic::where([['titre', 'LIKE', "%".$search."%"],['categorie_id', $categorie->id_categorie]])->orWhere([['description', 'LIKE', "%".$search."%"],['categorie_id', $categorie->id_categorie]])->orderBy('created_at' , 'DESC', 'updated_at' ,'DESC')->latest()->paginate(10);
        return view ('front.categorie.showCategorie', ['lesTopics' => $lesTopics, 'categorie' => $categorie]);
    }
}

saa/resources/views/admin/categorie/createCategorie.blade.php
@extends('layouts.admin')
@section('title', 'Création Catégorie')

@section('content')
    <div class="card card-primary">

        <!-- /.card-header -->
        <!-- form start -->
        <form method="POST" action="{{ route('categorie.store') }}" enctype="multipart/form-data" >
            @csrf
            @method('POST')
            <div class="card-body">
                <div class="row">
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="exampleInputEmail1">Titre</label>
                            <input type="text" class="form-control @error('titre_categorie') is-invalid @enderror"
                                id="titre_categorie" name="titre_categorie" placeholder="Entrer un titre " value="{{ old('titre_categorie') }}">
                            @error('titre_categorie') <span id="name-error"
                                class="error invalid-feedback">{{ $errors->first('titre_categorie') }}</span> @enderror
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="form-group">
                            <label for="logo_categorie">Logo de la catégorie</label>
                            <div class="input-group">
                                <div class="custom-file" style="display: unset;">
                                    <input type="file" class="custom-file-input  @error('logo_categorie') is-invalid @enderror" id="logo_categorie" name="logo_categorie">
                                    @error('logo_categorie') <span id="name-error"
                                    class="error invalid-feedback">{{ $errors->first('logo_categorie') }}</span> @enderror
                                    <label class="custom-file-label" for="logo_categorie">Choisir un fichier png,jpg,jpeg....</label>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row">
                    <div class="col-md-12">
                        <div class="form-group">
                            <label>Description</label>
                            <textarea class="form-control @error('description_categorie') is-invalid @enderror" rows="3"
                                placeholder="Entrer une description" name="description_categorie"
                                id="description_categorie" value="{{ old('description_categorie') }}"></textarea>
                            @error('description_categorie') <span id="name-error"
                                    class="error invalid-feedback">{{ $errors->first('description_categorie') }}</span>
                            @enderror
                        </div>
                    </div>
                </div>
            </div>
            <!-- /.card-body -->

            <div class="card-footer">
                <button type="submit" class="btn btn-primary">Créer</button>
            </div>
        </form>

    @section('script')
        <script type="text/javascript">
            $(document).ready(function() {
                bsCustomFileInput.init();
            });

        </script>
    @endsection
</div>
@endsection

saa/resources/views/admin/categorie/editCategorie.blade.php
@extends('layouts.admin')
@section('title', 'Modification du forum : '.$categorie->titre_categorie)

@section('content')
<div class="card card-primary">
    
    <!-- /.card-header -->
    <!-- form start -->
    <form method="POST" action="{{route('categorie.update', $categorie)}}" enctype="multipart/form-data">
      @csrf
      @method('PATCH')
        <div class="card-body">
          <div class="row">
              <div class="col-md-6">
  
          <div class="form-group">
            <label for="exampleInputEmail1">Titre</label>
              <input type="text" class="form-control @error('titre_categorie') is-invalid @enderror" id="titre_categorie" name="titre_categorie" placeholder="Entrer un titre " value="@if (old('titre_categorie')) {{old('titre_categorie')}} @else {{$categorie->titre_categorie}} @endif">    
            @error('titre_categorie') <span id="name-error" class="error invalid-feedback">{{$errors->first('titre_categorie')}}</span> @enderror
          </div>
        </div>
  
        <div class="col-md-6">
            <div class="form-group">
                <label for="logo_categorie">Logo de la catégorie</label>
                <div class="input-group">
                    <div class="custom-file" style="display: unset;">
               <input type="file" class="custom-file-input  @error('logo_categorie') is-invalid @enderror" id="logo_categorie" name="logo_categorie"  value="@if (old('logo_categorie')) {{old('logo_categorie')}} @else {{$categorie->logo_categorie}} @endif"> 
                         @error('logo_categorie') <span id="name-error" class="error invalid-feedback">{{ $errors->first('logo_categorie') }}</span> @enderror
                        <label class="custom-file-label" for="logo_categorie">@if($categorie->logo_categorie){{$categorie->logo_categorie}}@else Choisir un fichier png,jpg,jpeg....@endif</label>
                    </div>
                </div>
            </div>
        </div>

        
  
        <div class="col-md-12">
            <div class="form-group">
                <label>Description du forum</label>
                <textarea class="form-control @error('description_categorie') is-invalid @enderror" rows="3" placeholder="Entrer une description" value="{{old('description_categorie')}}" name="description_categorie" id="description_categorie">@if (old('description_categorie')) {{old('description_categorie')}} @else {{$categorie->description_categorie}} @endif</textarea>
                @error('description_categorie') <span id="name-error" class="error invalid-feedback">{{$errors->first('description_categorie')}}</span> @enderror
              </div>
            </div>
        </div>
  
        
          
        </div>
        <!-- /.card-body -->
  
        
  
        <div class="card-footer">
          <button type="submit" class="btn btn-primary">Modifier</button>
        </div>
      </form>
    </div>
  
    @section('script')
        <script type="text/javascript">
            $(document).ready(function() {
                bsCustomFileInput.init();
            });

        </script>
    @endsection





    
@endsection

saa/resources/views/admin/categorie/indexCategorie.blade.php
@extends('layouts.admin')
@section('title', 'Liste des Catégories')


@section('content')

<div class="col-md-2" style="margin-bottom:20px;">
  <a href="{{route('categorie.create')}}">  <button type="button" class="btn btn-block btn-success">Créer une catégorie <i class="fas fa-plus-square"></i></button> </a>
</div>

    <div class="card">
    <div class="card-body">
    <table id="table" class="table table-bordered table-striped table-hover dataTable" role="grid">
    <thead>
        <tr role="row">
            <th class="sorting_asc" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Titre</th>
            <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Description</th>
            <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Logo</th>
            <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Créer le</th>
            <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1">Modifié le</th>
            <th class="sorting" tabindex="0" aria-controls="table" rowspan="1" colspan="1" style="text-align: right">Action</th>
        </tr>
    </thead>
    <tbody>
        @foreach ($categories as $categorie)
            <tr role="row" class="odd">
                <td>{{$categorie->titre_categorie}}</td>
                <td>{{$categorie->description_categorie}}</td>
                <td><img src="{{asset('/storage/'.$categorie->logo_categorie)}}" width="45"></td>
                <td>{{$categorie->created_at}}</td>
                <td>{{$categorie->updated_at}}</td>
                <td>
                    <div class="text-center">
                        <a href="{{route('categorie.edit', $categorie)}}"><button type="button" class="btn btn-primary "><i class="fas fa-edit"></i></button></a>
                        <button type="button" class="btn btn-danger remove-categorie" data-name="{{ $categorie->titre_categorie}}" data-action="{{ route('categorie.destroy', $categorie) }}"><i class="fas fa-trash"></i></button>
                      </div>
                </td>
            </tr>
        @endforeach
        </tbody>
          </table>
        </div>
    </div>
    @section('script')
    <script>
        $(function() {
            $("#table").DataTable({
                "responsive": true,
                "autoWidth": false,
                "language": {
                    "url": "//cdn.datatables.net/plug-ins/9dcbecd42ad/i18n/French.json"
                },
            });
        });

        $("body").on("click", ".remove-categorie", function() {

            var current_object = $(this);
            var name = current_object.attr('data-name');

            swal.fire({

                title: "Êtes vous sur ?",
                text: "Voulez-vous vraiment supprimer la catégorie suivante : " + name + " ?",
                type: 'warning',
                showCancelButton: true,
                cancelButtonColor: '#6c757d',
                confirmButtonColor: '#dc3545',
                confirmButtonText: 'Supprimer !',
                reverseButtons: true

            }).then((result) => {

                if (result.value) {

                    var action = current_object.attr('data-action');

                    $('body').html("<form class='form-inline remove-form' method='post' action='" + action +
                        "'></form>");
                    $('body').find('.remove-form').append('@csrf');
                    $('body').find('.remove-form').append('@method('DELETE')');
                    $('body').find('.remove-form').submit();
                }

            });

        });

    </script>

@endsection 

@endsection